<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::basic_op_mm&lt; M1, M2 &gt; Struct Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="structdlib_1_1basic__op__mm.html">basic_op_mm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="structdlib_1_1basic__op__mm-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::basic_op_mm&lt; M1, M2 &gt; Struct Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::basic_op_mm&lt; M1, M2 &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structdlib_1_1basic__op__mm.png" usemap="#dlib::basic_5Fop_5Fmm_3C_20M1_2C_20M2_20_3E_map" alt=""/>
  <map id="dlib::basic_5Fop_5Fmm_3C_20M1_2C_20M2_20_3E_map" name="dlib::basic_5Fop_5Fmm_3C_20M1_2C_20M2_20_3E_map">
<area href="structdlib_1_1op__complex__matrix2.html" alt="dlib::op_complex_matrix2&lt; M1, M2 &gt;" shape="rect" coords="0,56,229,80"/>
<area href="structdlib_1_1op__diagm__mult.html" alt="dlib::op_diagm_mult&lt; M1, M2 &gt;" shape="rect" coords="239,56,468,80"/>
<area href="structdlib_1_1op__pointwise__multiply.html" alt="dlib::op_pointwise_multiply&lt; M1, M2 &gt;" shape="rect" coords="478,56,707,80"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:adaf94549ac6feaa63829e9feabf765c8"><td class="memItemLeft" align="right" valign="top"><a id="adaf94549ac6feaa63829e9feabf765c8"></a>
typedef M1::mem_manager_type&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:adaf94549ac6feaa63829e9feabf765c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33846f38d0803cc36515132260c71676"><td class="memItemLeft" align="right" valign="top"><a id="a33846f38d0803cc36515132260c71676"></a>
typedef M1::layout_type&#160;</td><td class="memItemRight" valign="bottom"><b>layout_type</b></td></tr>
<tr class="separator:a33846f38d0803cc36515132260c71676"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0a43d24b12e70b4a60d7b7b791c58246"><td class="memItemLeft" align="right" valign="top"><a id="a0a43d24b12e70b4a60d7b7b791c58246"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>basic_op_mm</b> (const M1 &amp;m1_, const M2 &amp;m2_)</td></tr>
<tr class="separator:a0a43d24b12e70b4a60d7b7b791c58246"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94a503173d92df54fd2161fd4e4b61ba"><td class="memItemLeft" align="right" valign="top"><a id="a94a503173d92df54fd2161fd4e4b61ba"></a>
long&#160;</td><td class="memItemRight" valign="bottom"><b>nr</b> () const</td></tr>
<tr class="separator:a94a503173d92df54fd2161fd4e4b61ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0fe35e705b860bec3a81e09a7d7920c"><td class="memItemLeft" align="right" valign="top"><a id="af0fe35e705b860bec3a81e09a7d7920c"></a>
long&#160;</td><td class="memItemRight" valign="bottom"><b>nc</b> () const</td></tr>
<tr class="separator:af0fe35e705b860bec3a81e09a7d7920c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a76adf3aeb0b3f0290c37d6d891e41824"><td class="memTemplParams" colspan="2"><a id="a76adf3aeb0b3f0290c37d6d891e41824"></a>
template&lt;typename U &gt; </td></tr>
<tr class="memitem:a76adf3aeb0b3f0290c37d6d891e41824"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><b>aliases</b> (const <a class="el" href="classdlib_1_1matrix__exp.html">matrix_exp</a>&lt; U &gt; &amp;item) const</td></tr>
<tr class="separator:a76adf3aeb0b3f0290c37d6d891e41824"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c21979c1f1382520bcd73ce63ff05f1"><td class="memTemplParams" colspan="2"><a id="a6c21979c1f1382520bcd73ce63ff05f1"></a>
template&lt;typename U &gt; </td></tr>
<tr class="memitem:a6c21979c1f1382520bcd73ce63ff05f1"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><b>destructively_aliases</b> (const <a class="el" href="classdlib_1_1matrix__exp.html">matrix_exp</a>&lt; U &gt; &amp;item) const</td></tr>
<tr class="separator:a6c21979c1f1382520bcd73ce63ff05f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a7ee82fc81c2300e1f8356b7c1d2febcd"><td class="memItemLeft" align="right" valign="top"><a id="a7ee82fc81c2300e1f8356b7c1d2febcd"></a>
const M1 &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>m1</b></td></tr>
<tr class="separator:a7ee82fc81c2300e1f8356b7c1d2febcd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbebde1f16091c23964ae56492649863"><td class="memItemLeft" align="right" valign="top"><a id="adbebde1f16091c23964ae56492649863"></a>
const M2 &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>m2</b></td></tr>
<tr class="separator:adbebde1f16091c23964ae56492649863"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a4b3d215d756b92d484b2072c0133ff51"><td class="memItemLeft" align="right" valign="top"><a id="a4b3d215d756b92d484b2072c0133ff51"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>NR</b> = M1::NR</td></tr>
<tr class="separator:a4b3d215d756b92d484b2072c0133ff51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a288289ee911b5f9f3e9ef73cac63775d"><td class="memItemLeft" align="right" valign="top"><a id="a288289ee911b5f9f3e9ef73cac63775d"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>NC</b> = M1::NC</td></tr>
<tr class="separator:a288289ee911b5f9f3e9ef73cac63775d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:aa9407f24c64244a4c57abed2806e01b0"><td class="memTemplParams" colspan="2">template&lt;typename T1 , typename T2 &gt; </td></tr>
<tr class="memitem:aa9407f24c64244a4c57abed2806e01b0"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="structdlib_1_1basic__op__mm.html#aa9407f24c64244a4c57abed2806e01b0">basic_op_mm</a> (T1, T2)</td></tr>
<tr class="separator:aa9407f24c64244a4c57abed2806e01b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa9407f24c64244a4c57abed2806e01b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa9407f24c64244a4c57abed2806e01b0">&#9670;&nbsp;</a></span>basic_op_mm()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename M1 , typename M2 &gt; </div>
<div class="memtemplate">
template&lt;typename T1 , typename T2 &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structdlib_1_1basic__op__mm.html">dlib::basic_op_mm</a>&lt; M1, M2 &gt;::<a class="el" href="structdlib_1_1basic__op__mm.html">basic_op_mm</a> </td>
          <td>(</td>
          <td class="paramtype">T1&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T2&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">This is a partial implementation of a matrix operator that preserves
the dimensions of its arguments and doesn't have destructive aliasing.
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="matrix__op_8h_source.html">matrix_op.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
